class NameSpace {

       variable counter 0
       variable cookie
       variable icomponentdata
       variable canvas 


constructor {mycanvas } {
	set canvas $mycanvas 
       VisNode  $this-root $canvas -icon1 dirclosed  \
	-icon dirclosed \
	-icon2 diropen -title "eComanche"
	 $this-root set_data NameSpace $this

       array set cookie ""
       array set icomponentdata ""

}

public method GetRoot {} 
public method Refresh {} 

public method GetDescendants {hScopeItem} 
public method GetNameSpaceInfo {hScopeItem} 
public method AddItem {ScopeDataItem} 
public method DeleteItem {hScopeItem} 
public method Notify {message hscopeitem}
public method CreateMenu {IComponentData cookie}


}

body NameSpace::Notify {message hscopeitem} {


switch $message TOGGLE { 
	if ![string compare $hscopeitem $this-root] { $hscopeitem toggle; return}
	# Esto de momento
	
	if ![string compare [$hscopeitem cget -state] closed]  { 
		if [$hscopeitem cget -virgin] {$icomponentdata($hscopeitem) Notify EXPAND $cookie($hscopeitem); $hscopeitem configure -virgin 0 }

	}

	$hscopeitem toggle

} SELECT {
	if ![string compare $hscopeitem $this-root] { $hscopeitem select;\
	global MyHelpVbl; set MyHelpVbl {Double-click to expand} ; return}
	
	set info(cookie) $cookie($hscopeitem)
	$icomponentdata($hscopeitem) GetNodeInfo info

	
	# Aqui lo que ocurriria es que se le pregunta al nodo que ha sido seleccionado. Si no hace nada, simplemente
	# AL Console Result le anadimos los hijos del que se haya seleccionado
	if [$hscopeitem cget -virgin] {$icomponentdata($hscopeitem) Notify EXPAND $cookie($hscopeitem); $hscopeitem configure -virgin 0 }
        global myHelpVbl; set myHelpVbl "Right click on the object to see menu"
	$hscopeitem select
	switch $info(NodeType) directory - location - virtualhost - mainserver { } management { } default {}
     
	
} RIGHT-CLICK {

 	$this Notify SELECT $hscopeitem

	catch [set info(cookie) $cookie($hscopeitem);
	$icomponentdata($hscopeitem) GetNodeInfo info;
        CreateMenu $icomponentdata($hscopeitem) $cookie($hscopeitem);
 	$this Notify SELECT $hscopeitem]


}


}


body NameSpace::GetRoot {} {return $this-root}
body NameSpace::Refresh {} {$this-root refresh}

body NameSpace::AddItem {pScopeDataItem} {

	upvar $pScopeDataItem ScopeDataItem
	set hScopeItem $this-[incr counter]

	set parentNode $ScopeDataItem(parent)

	set cookie($hScopeItem) $ScopeDataItem(pSnapInItem)
	set icomponentdata($hScopeItem) $ScopeDataItem(pIComponentData)

	# Aqui asignar icono o lo que sea que venga de esa estructura
	# O hacerlo con llamadas a IComponentData

	set ScopeItemInfo(cookie) $cookie($hScopeItem)

	$icomponentdata($hScopeItem) GetDisplayInfo ScopeItemInfo

	VisNode $hScopeItem $canvas -icon2 $ScopeItemInfo(ScopePaneIconOpen)  \
	-icon $ScopeItemInfo(ScopePaneIconClosed) \
	-icon1 $ScopeItemInfo(ScopePaneIconClosed) -title "$ScopeItemInfo(ScopePaneTitle)"	
	$hScopeItem set_data NameSpace $this
	$parentNode add $hScopeItem


	return $hScopeItem


}

body NameSpace::DeleteItem {hScopeItem} {
	
	unset cookie($hScopeItem)
	[$hScopeItem ascendant] remove $hScopeItem
		
}

body NameSpace::GetDescendants {hScopeItem} {
	
	
	return [$hScopeItem contents] 
	
	
}

body NameSpace::GetNameSpaceInfo {hScopeItem} {
	
	return "$cookie($hScopeItem) $icomponentdata($hScopeItem)"
		
}

body NameSpace::CreateMenu {IComponentData thecookie} {

# Para el futuro, se crea un objeto menu al que todos los snapin que quieran
# van anadiendo cosas y luego al final se inicializa. Bueno, mejor lo
# hacemos ahora con llamadas a los Snapins y vamos recogiendo lo que nos
# mandan

# De momento creamos los menus aqui, y alo haremos mejor en el futuro. Switch y copy and paste

# This is one of the things that is going to change, so each snap-in can add menu entires, etc

catch [destroy .mymenu]
catch [unset info]

set info(cookie) $thecookie
$IComponentData GetNodeInfo info

switch $info(NodeType) MainNode {
createUnacceleratedMenu .mymenu  myHelpVbl -tearoff 0   -contents  [list \
cascade [list -label "New" -help "Create a new object in this container" \
-submenu [list  -tearoff 0 -contents [list  \
 command [list -label "Virtual Host" -command "PromptForVirtualHost $IComponentData $thecookie; $this Refresh"] \
] \
] \
] \
separator {} \
command [list -label "Delete" -help "Delete this object" -command  "$IComponentData Notify DELETE $thecookie"] \
command {-label "Copy" -help "Copy the contents of this node (not working yet)"} \
command {-label "Refresh" -help "Refresh Contents"} \
separator {} \
command {-label "Properties" -help ""} ]

} mainserver {
createUnacceleratedMenu .mymenu  myHelpVbl -tearoff 0   -contents  [list \
cascade [list -label "New" -help "Create a new object in this container" \
-submenu [list  -tearoff 0 -contents [list  \
 command [list -label "Directory" -command "PromptForDirectory $IComponentData $thecookie; $this Refresh"] \
 command [list -label "Location" -command "PromptForLocation $IComponentData $thecookie; $this Refresh"] \
  command { -label "Limit" }  \
] \
] \
] \
separator {} \
command [list -label "Delete" -help "Delete this object" -command  "$IComponentData Notify DELETE $thecookie"] \
command {-label "Copy" -help "Copy the contents of this node (not working yet)"} \
command {-label "Refresh" -help "Refresh Contents"} \
separator {} \
command [list -label "Properties" -help "" -command "CreateMainServerPP $IComponentData $thecookie " ] \
separator {} \
command [list -label "Conf view" -help "View conf file to be generated" \
-command "View $IComponentData $thecookie" ]]

} virtualhost {
createUnacceleratedMenu .mymenu  myHelpVbl -tearoff 0   -contents  [list \
cascade [list -label "New" -help "Create a new object in this container" \
-submenu [list  -tearoff 0 -contents [list  \
 command [list -label "Directory" -command "PromptForDirectory $IComponentData $thecookie; $this Refresh"] \
 command [list -label "Location" -command "PromptForLocation $IComponentData $thecookie; $this Refresh"] \
 command { -label "Limit" }  \
] \
] \
] \
separator {} \
command [list -label "Delete" -help "Delete this object" -command  "$IComponentData Notify DELETE $thecookie"] \
command {-label "Copy" -help "Copy the contents of this node"} \
command {-label "Refresh" -help "Refresh Contents"} \
separator {} \
command [list -label "Properties" -help "" -command "CreateVirtualHostPP \
$IComponentData $thecookie "] \
separator {} \
command [list -label "Conf view" -help "View conf file to be generated" \
-command "View $IComponentData $thecookie" ]]


} directory - location - limit {

createUnacceleratedMenu .mymenu  myHelpVbl -tearoff 0   -contents [list \
command [list -label "Delete" -help "Delete this object" -command "$IComponentData Notify DELETE $thecookie"] \
command {-label "Copy" -help "Copy the contents of this node (not working yet)"} \
command {-label "Refresh" -help "Refresh Contents"} \
separator {} \
command [list -label "Properties" -help "" -command "CreateDirectoryPP $IComponentData $thecookie "] \
separator {} \
command [list -label "Conf view" -help "View conf file to be generated" \
-command "View $IComponentData $thecookie" ]]



} management {

createUnacceleratedMenu .mymenu  myHelpVbl -tearoff 0   -contents [list \
command [list -label "Stop" -help "Stop webserver" -command "ApacheCtl stop "] \
command [list -label "Start" -help "Start webserver" -command "ApacheCtl start"] \
command [list -label "Restart" -help "Restart webserver" -command "ApacheCtl restart"] \
command [list -label "Status" -help "Check if webserver running" -command "ApacheCtl status"] \
separator {} \
command [list -label "Save config" -help "Save actual configuration" \
-command "cnftree Save \[cnftree GetRoot\]" ]]

} default {set MyHelpVbl ""}



tk_popup .mymenu [winfo pointerx .] [winfo pointery .]


}


proc PromptForDirectory {Icomponentdata cookie} {

if ![winfo exists .pfd] {
iwidgets::promptdialog .pfd -modality application -title {Add new directory} -labeltext {Name of the new directory to add}
.pfd hide Apply
}

if {[.pfd activate]} {
set name [.pfd get]
set node [ConfNodeAp #auto]
$node set_data type directory
$node set_data dir_value "<directory \"$name\">"
$node configure  -title "$name"
$node set_data dir_class container
set info(cookie) $cookie
$Icomponentdata GetNodeInfo info
$info(CnfNode) add $node
$Icomponentdata AddNewDirectory $node $cookie
}


}


proc PromptForLocation {Icomponentdata cookie} {

if ![winfo exists .pfl] {
iwidgets::promptdialog .pfl -modality application -title {Add new location}\
-labeltext {Name of the new location to add }
.pfl hide Apply
}

if {[.pfl activate]} {
set name [.pfl get]
set node [ConfNodeAp #auto]
$node set_data type location
$node set_data dir_value "<location \"$name\">"
$node configure  -title "$name"
$node set_data dir_class container
set info(cookie) $cookie
$Icomponentdata GetNodeInfo info
$info(CnfNode) add $node
$Icomponentdata AddNewLocation $node $cookie
}


}

proc PromptForVirtualHost {Icomponentdata cookie} {

if ![winfo exists .pfvh] {
iwidgets::promptdialog .pfvh -modality application -title {Add new Virtual\
Host} -labeltext {Name of the new Virtual Host to add}
.pfvh hide Apply
}

if {[.pfvh activate]} {
set name [.pfvh get]
set node [ConfNodeAp #auto]
$node set_data type virtualhost
$node set_data dir_value "<virtualhost \"$name\" >"
$node configure  -title "$name"
$node set_data dir_class container
set info(cookie) $cookie
$Icomponentdata GetNodeInfo info
$info(CnfNode) add $node
$Icomponentdata AddNewVirtualHost $node 

}


}
